// GeoArc.cpp: implementation of the CGeoArc class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GeoArc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL(CGeoArc, CObject, VERSIONABLE_SCHEMA | GEOIO_MODULE_VERSION_NUM)

CGeoArc::CGeoArc()
{
	SetEntityType(GEOIO_ARC);
}

CGeoArc::CGeoArc(CGeoArc& pEntity)
{
	SetEntityType(pEntity.GetEntityType());
	SetEntityNumber(pEntity.GetEntityNumber());
	SetStartPoint(pEntity.GetStartPoint());
	SetEndPoint(pEntity.GetEndPoint());
	SetEntityColor(pEntity.GetEntityColor());
	m_CenterPnt.x = pEntity.m_CenterPnt.x;
	m_CenterPnt.y = pEntity.m_CenterPnt.y;
	m_fRadius = pEntity.m_fRadius;
}

CGeoArc::~CGeoArc()
{

}


/***********************************************************************************
		This fuction draws the arc with m_StPnt as start point and
		m_EndPnt as end point. pass the DC of the view class
***********************************************************************************/
void CGeoArc::Draw(CDC *pDC)
{
	CPen pen(PS_SOLID, 0, m_clr);
	pDC->SelectObject(&pen);

	CPoint pnt;
	pnt.x = m_CenterPnt.x + (int)m_fRadius;
	pnt.y = m_CenterPnt.y;
	pDC->MoveTo(pnt.x, pnt.y);
	pDC->AngleArc( m_CenterPnt.x, m_CenterPnt.y, (int)m_fRadius, m_StAngle, m_EndAngle);

}

// store or load
void CGeoArc::Serialize(CArchive& ar)
{
	CPrimitive::Serialize(ar);

	if (ar.IsStoring())
	{	// storing code
		ar << m_CenterPnt.x;
		ar << m_CenterPnt.y;
		ar << m_fRadius;
	}
	else
	{	// loading code
		ar >> m_CenterPnt.x;
		ar >> m_CenterPnt.y;
		ar >> m_fRadius;
	}
}

/*---------------------------------------------------------------------------------
	Function to determine if the point passed is near the entity
---------------------------------------------------------------------------------*/
void CGeoArc::PointNearEntity(CPoint pnt)
{
}

/*---------------------------------------------------------------------------------
	Function to delete the entity
---------------------------------------------------------------------------------*/
void CGeoArc::DeleteEntity()
{
	SetDeleted();
}

/*---------------------------------------------------------------------------------
	Function to determine if the point passed is near the entity
---------------------------------------------------------------------------------*/
BOOL CGeoArc::IsPointNearEntity(CPoint refPnt)
{
	return 1;
}

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to X-axis
---------------------------------------------------------------------------------*/
void CGeoArc::MirrorAboutXaxis()
{
	/* To mirror a arc about X-axis, negate the centre, start and 
	   end points' Ycoordinate*/
	m_StPnt.y = -(m_StPnt.y);	
	m_CenterPnt.y = -(m_CenterPnt.y);	
	m_EndPnt.y = -(m_EndPnt.y);
}

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to y-axis
---------------------------------------------------------------------------------*/
void CGeoArc::MirrorAboutYaxis()
{
	/* To mirror a arc about Y-axis, negate the centre, start and 
	   end points' Xcoordinate*/
	m_StPnt.x = -(m_StPnt.x);	
	m_CenterPnt.x = -(m_CenterPnt.x);	
	m_EndPnt.x = -(m_EndPnt.x);
}

/*---------------------------------------------------------------------------------
	Function to clone the entity. This function returns a new pointer to
	cloned entity.
---------------------------------------------------------------------------------*/
CPrimitive* CGeoArc::CreateClone()
{
	CGeoArc* pClone = new CGeoArc(*this);
	return pClone;
}