/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// GeoArc.h: interface for the CGeoArc class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __GEOARC_H__
#define __GEOARC_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CGeoArc : public CPrimitive  
{
	DECLARE_SERIAL(CGeoArc)
public:
	BOOL IsPointNearEntity(CPoint refPnt);
	void DeleteEntity();
	
	CGeoArc();
	CGeoArc(CGeoArc& pEntity);
	//CGeoArc(arctype &arc);
	virtual ~CGeoArc();

	CPoint m_CenterPnt;
	float m_fRadius;
	float m_StAngle;
	float m_EndAngle;

	CPrimitive* CreateClone();
	void MirrorAboutXaxis(void);
	void MirrorAboutYaxis(void);
	void PointNearEntity(CPoint pnt);
	void Serialize(CArchive& ar);
	void Draw(CDC *pDC);
};

#endif // __GEOARC_H__
