/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// GeoPolybezier.h: interface for the CGeoPolybezier class.
//
//////////////////////////////////////////////////////////////////////


#ifndef __GEOPOLYBEZIER_H__
#define __GEOPOLYBEZIER_H__


#include "stdafx.h"
#include "Primitive.h"


class GEOIO_EXPORT CGeoPolybezier : public CPrimitive  
{
	DECLARE_SERIAL(CGeoPolybezier)
public:
	BOOL IsPointNearEntity(CPoint refPnt);
	CGeoPolybezier();
	CGeoPolybezier(CGeoPolybezier& pEntity);
	virtual ~CGeoPolybezier();

	CArray<POINT,POINT> m_ControlPoints;

	BOOL IsInsideControlPoint(POINT& point);
	void AddControlPoint(CPoint pnt);
	void DeleteEntity();
	CPrimitive* CreateClone();
	void MirrorAboutXaxis(void);
	void MirrorAboutYaxis(void);
	void PointNearEntity(CPoint pnt);
	void Serialize(CArchive& ar);
	void Draw(CDC *pDC);

private:
	double Distance(const POINT& p1, const POINT& p2);
};

#endif // __GEOPOLYBEZIER_H__
