// GeoRectangle.cpp: implementation of the CGeoRectangle class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "GeoRectangle.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

IMPLEMENT_SERIAL(CGeoRectangle, CObject, VERSIONABLE_SCHEMA | GEOIO_MODULE_VERSION_NUM)

CGeoRectangle::CGeoRectangle()
{
	SetEntityType(GEOIO_RECTANGLE);
}

CGeoRectangle::CGeoRectangle(CGeoRectangle& pEntity)
{
	SetEntityType(pEntity.GetEntityType());
	SetEntityNumber(pEntity.GetEntityNumber());
	SetStartPoint(pEntity.GetStartPoint());
	SetEndPoint(pEntity.GetEndPoint());
	SetEntityColor(pEntity.GetEntityColor());
}

CGeoRectangle::~CGeoRectangle()
{

}


/***********************************************************************************
		This fuction draws the rectangle with m_StPnt as top left point and
		m_EndPnt as bottom right point. pass the DC of the view class
***********************************************************************************/
void CGeoRectangle::Draw(CDC *pDC)
{
	CPen pen(PS_SOLID, 0, m_clr);
	pDC->SelectObject(&pen);

	pDC->MoveTo(m_StPnt.x, m_StPnt.y);
	pDC->LineTo(m_EndPnt.x, m_StPnt.y);
	pDC->LineTo(m_EndPnt.x, m_EndPnt.y);
	pDC->LineTo(m_StPnt.x, m_EndPnt.y);
	pDC->LineTo(m_StPnt.x, m_StPnt.y);
}

// store or load
void CGeoRectangle::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{	// storing code
		
	}
	else
	{	// loading code
		
	}

	CPrimitive::Serialize(ar);
}

/***********************************************************************************
	Function to determine if the point passed is near the entity
***********************************************************************************/
void CGeoRectangle::PointNearEntity(CPoint pnt)
{
}

void CGeoRectangle::DeleteEntity()
{
	SetDeleted();
}

BOOL CGeoRectangle::IsPointNearEntity(CPoint refPnt)
{
	return TRUE;
}	

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to X-axis
---------------------------------------------------------------------------------*/
void CGeoRectangle::MirrorAboutXaxis()
{
	/* To mirror a rectangle about X-axis, negate the start and 
	   end points' Ycoordinate*/
	m_StPnt.y = -(m_StPnt.y);
	m_EndPnt.y = -(m_EndPnt.y);
}

/*---------------------------------------------------------------------------------
	Function to mirror entity with respect to y-axis
---------------------------------------------------------------------------------*/
void CGeoRectangle::MirrorAboutYaxis()
{
	/* To mirror a rectangle about Y-axis, negate the start and 
	   end points' Xcoordinate*/
	m_StPnt.x = -(m_StPnt.x);
	m_EndPnt.x = -(m_EndPnt.x);
}

/*---------------------------------------------------------------------------------
	Function to clone the entity. This function returns a new pointer to
	cloned entity.
---------------------------------------------------------------------------------*/
CPrimitive* CGeoRectangle::CreateClone()
{
	CGeoRectangle* pClone = new CGeoRectangle(*this);
	return pClone;
}