/*
 *  By: Sunil Kumar
 *  GeoIO Module. Module to draw simple 2D geometry objects and serialization.
 *  This code is free and is distributed in the hope that it will be useful for simple learning and experimental purpose only WITHOUT any WARRANTY.
 *  The author shall hold no redistribution liability in case of any unethical usage/modification.
 *  Distributed under CPOL.
 */
// GeoRectangle.h: interface for the CGeoRectangle class.
//
//////////////////////////////////////////////////////////////////////

#ifndef __GEORECTANGLE_H__
#define __GEORECTANGLE_H__

#include "stdafx.h"
#include "Primitive.h"

class GEOIO_EXPORT CGeoRectangle  : public CPrimitive
{
	DECLARE_SERIAL(CGeoRectangle)
public:
	CGeoRectangle();
	CGeoRectangle(CGeoRectangle& pEntity);
	virtual ~CGeoRectangle();

	BOOL IsPointNearEntity(CPoint refPnt);
	void DeleteEntity();
	CPrimitive* CreateClone();
	void MirrorAboutXaxis(void);
	void MirrorAboutYaxis(void);
	void PointNearEntity(CPoint pnt);
	void Serialize(CArchive& ar);
	void Draw(CDC *pDC);
};
#endif // __GEORECTANGLE_H__
